<?php

/*

ipn.php - example code used for the tutorial:



PayPal IPN with PHP

How To Implement an Instant Payment Notification listener script in PHP

http://www.micahcarrick.com/paypal-ipn-with-php.html



(c) 2011 - Micah Carrick

*/

$a = session_id();

if(empty($a)) session_start();





// database settings

$ipnhost="localhost";

$ln="andacco1_admin";

$pw="BadgersArse2012#~@";

$paypaldb="andacco1_paypal";



// paypal email

$paypal_email = "sales@redbrooktech.com";



// email address where script should send notifications

$error_email = "jimdunstan@gmail.com";



// email header

$em_headers  = "From: Jim Dunstan <sales@redbrooktech.com>\n";		

$em_headers .= "Reply-To: sales@redbrooktech.com\n";

$em_headers .= "Return-Path: sales@redbrooktech.com\n";

$em_headers .= "Organization: Redbrook Technology\n";

$em_headers .= "X-Priority: 3\n";



// tell PHP to log errors to ipn_errors.log in this directory

ini_set('log_errors', true);

ini_set('error_log', dirname(__FILE__).'/ipn_errors.log');



// intantiate the IPN listener

include('ipnlistener.php');

$listener = new IpnListener();



// tell the IPN listener to use the PayPal test sandbox

$listener->use_sandbox = false;



// try to process the IPN POST

try {

    $listener->requirePostMethod();

    $verified = $listener->processIpn();

} catch (Exception $e) {

    error_log($e->getMessage());

    exit(0);

}



if ($verified) {

    $qry = "";

    $res ="";

    $config ="";

    $conn = "";



    try {

            $qry= "SELECT i.mc_gross, i.mc_currency FROM item_table as i WHERE i.item_number='" . $_POST['item_number'] . "'";

            $conn = mysqli_connect("$ipnhost","$ln","$pw") or die("Unable to connect to database");

            mysqli_select_db($conn, "$paypaldb") or die("Unable to select database");

            $res=mysqli_query ($conn, $qry);

            $config=mysqli_fetch_array($res);



        } catch (Exception $e) {

        error_log($e->getMessage());

        exit(0);

    }	



    $errmsg = '';   // stores errors from fraud checks

    

    // 1. Make sure the payment status is "Completed" 

    if ($_POST['payment_status'] != 'Completed') { 

        // simply ignore any IPN that is not completed

        exit(0); 

    }



    // 2. Make sure seller email matches your primary account email.

    if ($_POST['receiver_email'] != $paypal_email) {

        $errmsg .= "'receiver_email' does not match: ";

        $errmsg .= $_POST['receiver_email']."\n";

    }

    

    // 3. Make sure the amount(s) paid match

    if($_POST['item_number'] == "tb2")

    {

        if ($_POST['mc_gross'] != '195') {

            $errmsg .= "'mc_gross' does not match: ";

            $errmsg .= $_POST['mc_gross']."\n";

        }

    }



    if($_POST['item_number'] == "evo")

    {

        if ($_POST['mc_gross'] != '145') {

            $errmsg .= "'mc_gross' does not match: ";

            $errmsg .= $_POST['mc_gross']."\n";

        }

    }



    if($_POST['item_number'] == "cs1")

    {

        if ($_POST['mc_gross'] != '45') {

                $errmsg .= "'mc_gross' does not match: ";

                $errmsg .= $_POST['mc_gross']."\n";

        }

    }



    // 4. Make sure the currency code matches

    if ($_POST['mc_currency'] != 'GBP') {

        $errmsg .= "'mc_currency' does not match: ";

        $errmsg .= $_POST['mc_currency']."\n";

    }



    // 5. Ensure the transaction is not a duplicate.

    //mysqli_connect('localhost', 'DB_USER', 'DB_PW') or exit(0);

    //mysqli_select_db('DB_NAME') or exit(0);



   /* $txn_id = mysqli_real_escape_string($_POST['txn_id']);

    $sql = "SELECT COUNT(*) FROM paypal_table WHERE txn_id = '$txn_id'";

    $r = mysqli_query($conn, $sql);

    

    if (!$r) {

        error_log(mysqli_error($conn));

        exit(0);

    }

    

    $exists = mysqli_result($r, 0);

    mysqli_free_result($r);

    

    if ($exists) {

        $errmsg .= "'txn_id' has already been processed: ".$_POST['txn_id']."\n";

    }

    */



    if (!empty($errmsg)) {

    

        // manually investigate errors from the fraud checking

        $body = "IPN failed fraud checks: \n$errmsg\n\n";

        $body .= $listener->getTextReport();

        mail($error_email, 'IPN Fraud Warning', $body);

        

    } else {

    

        // add this order to a table of completed orders

        $payer_email = mysqli_real_escape_string($_POST['payer_email']);

        $mc_gross = mysqli_real_escape_string($_POST['mc_gross']);



        $sql="INSERT INTO paypal_table VALUES (0 , '" . $_POST['payer_id'] . "', '" . $_POST['payment_date'] . "', '" . $_POST['txn_id'] . "', '" . $_POST['first_name'] . "', '" . $_POST['last_name'] . "', '" . $_POST['payer_email'] . "', '" . $_POST['payer_status'] . "', '" . $_POST['payment_type'] . "', '" . $_POST['memo'] . "', '" . $_POST['item_name'] . "', '" . $_POST['item_number'] . "', ". $_POST['quantity'] .",". $_POST['mc_gross']. ",'". $_POST['mc_currency']."','". $_POST['address_name'] ."', '".nl2br($_POST['address_street'])."', '" . $_POST['address_city'] . "', '" . $_POST['address_state'] . "','". $_POST['address_zip'] ."','". $_POST['address_country'] ."','". $_POST['address_status'] ."','". $_POST['payer_business_name'] . "','". $_POST['payment_status'] ."','" . $_POST['pending_reason'] . "','". $_POST['reason_code'] ."','". $_POST['txn_type'] ."')";



        if (!mysqli_query($conn, $sql)) {

            error_log(mysqli_error($conn));

            exit(0);

        }

		

		if($_POST['item_number'] == "tb2")

		{

		    $str= date('is',time()) .'-'.substr(session_id(),4,4) .'-'.substr(session_id(),8,4);

			$client = new SoapClient("http://pendragonrepairs.com/WSEvoAuthent/tbService.asmx?wsdl");



			$resauth = $client->createTBUser(array("authcode" => $str,"users" => "50"));

			if( $resauth->createTBUserResult == true)

			{

			    $headers = 'From: sales@redbrooktech.com' . "\r\n" .

							'Reply-To: sales@redbrooktech.com' . "\r\n" .

							'X-Mailer: PHP/' . phpversion();

							

			    $em = "Dear " . $_POST['first_name'] ." " . $_POST['last_name'] .",\r\n Greetings from Redbrook Technology and thank you for buying Trailblazer.\r\n \r\nYour keycode  is:$str \r\n \r\n Regards,\r\n Jim Dunstan \r\n Redbrook Technology";

				mail($payer_email,'Trailblazer purchase',$em, 'From: sales@redbrooktech.com');
				mail('info@redbrooktech.com','Trailblazer converter purchase ',$em);

			}else

			{

				$em = "<H1>Purchase failure</h2><p>User email - $payer_email </p>";

				mail('info@redbrooktech.com','Trailblazer purchase failure','$em');

			}

		}

											

        if($_POST['item_number'] == "evo" )

		{



			$str= date('is',time()) .'-'.substr(session_id(),4,4) .'-'.substr(session_id(),8,4);

            $client = new SoapClient("http://pendragonrepairs.com/WSEvoAuthent/Service.asmx?wsdl");

            $resauth = $client->registeruser(array("authcode" => $str,"macname" => "","custname" => "","fname" => ""));



			if( $resauth->registeruserResult == "1")

			{

				$headers = 'From: sales@redbrooktech.com' . "\r\n" .

							'Reply-To: sales@redbrooktech.com' . "\r\n" .

							'X-Mailer: PHP/' . phpversion();

			    $em = "Dear " . $_POST['first_name'] ." " . $_POST['last_name'] .",\r\n Greetings from Redbrook Technology and thank you for buying the Redbrook Technology Access to VB.NET converter\r\n \r\nYour key code for the Access converter is: $str \r\n \r\n Regards,\r\n Jim Dunstan \r\n Redbrook Technology";

				mail($payer_email,'Redbrook Technology Access to VB.NET converter',$em,'From: sales@redbrooktech.com');

				mail('info@redbrooktech.com','Access converter purchase ',$em);

			}else

			{

				$em = "<H1>Purchase failure</h2><p>User email - $payer_email </p>";

				mail('info@redbrooktech.com','Access converter purchase failure',$em);

			}

        }

    }

    

} else {

    // manually investigate the invalid IPN

    mail($error_email, 'Invalid IPN', $listener->getTextReport());

}



?>